/* 
	-- iPalmMemoWidget.js
	-- iPalmMemoWidget
	
	-- Created by ?? ? on 05/05/25
	-- Copyright (c) 2005 QueueSoft. All rights reserved.
*/
var version = 'iPalmMemo Widget Ver 1.1';
var timerInterval = null;
var select_user = 0;
var memo_count = 0;
var memoIdx = 0;
var refreshSecond = 30 * 1000;

function getLocalizedString (key)
{
	try {
		return localizedStrings[key];
	} catch (ex) {}

	return key;
}

function onshow () {
//	MailUnreadPlugin.logMessage("js:onshow");

	if (timerInterval == null) {
		timerInterval = setInterval("refreshScreen();",refreshSecond);
	}
	refreshScreen();
}

function onhide () {
//	MailUnreadPlugin.logMessage("js:onhide");

	if (timerInterval != null) {
		// clear the timer
		clearInterval(timerInterval);
		timerInterval = null;
	}
}

function loaded() {

	document.getElementById("user-label").innerHTML = getLocalizedString ("label_user")
	document.getElementById("category-label").innerHTML = getLocalizedString ("label_category")
	
// restore saved user No
	if (window.widget) {
		var save_user = widget.preferenceForKey(createkey("user"));
		if(save_user != null)
			select_user = save_user;
		else
			select_user = -1;
	}

	memoIdx = -1;

	if(iPalmMemoPlugin.getUserCount() > 0) {
		if(select_user < 0)
			select_user = 0;
		iPalmMemoPlugin.setUser(select_user);
		memo_count = iPalmMemoPlugin.getMemoCount();
		if(memo_count > 0) {
			memoIdx = 0;
		}
	}

	refreshScreen();
}

function refreshScreen()
{
	if(select_user >= 0) {
		if(iPalmMemoPlugin.getUserCount() > 0) {
			refresh();
		}
	}
}

function clickedLeftButton(event) {
	event.target.src = "Images/ab_pressbk.png";
	
	if(memoIdx == -1)
		return;
	memoIdx--;
	if(memoIdx < 0) {
		memoIdx = memo_count - 1;
	}

	refresh();
}

function clickedRightButton(event) {
	event.target.src = "Images/ab_pressfwd.png";

	if(memoIdx == -1)
		return;
	memoIdx++;
	if(memoIdx >= memo_count) {
		memoIdx = 0;
	}

	refresh();
}

function mouseUp(event, tag)
{
	event.target.src = "Images/"+tag+".png";
}

function refresh()
{
	memoNumberDiv = document.getElementById('MemoNumberDiv');
	mem_cnt = iPalmMemoPlugin.getMemoCount();
	if(mem_cnt <= 0) {
		memoNumberDiv.innerHTML = '0 / ' + mem_cnt;
	} else {
		memoNumberDiv.innerHTML = (memoIdx + 1) + ' / ' + mem_cnt;
	}

	document.getElementById('memoContent').value = iPalmMemoPlugin.getMemoAtIndex(memoIdx);
	document.getElementById('memoContent').blur();
}

function UserSelect()
{
	memo_count = 0;
	var select = document.getElementById ('user-popup');
	var c = iPalmMemoPlugin.getUserCount();
	
	for (var i = 0; i < c; ++i)
	{
		var element = document.createElement("option");
		element.innerText = iPalmMemoPlugin.getUserAtIndex(i);
		select.appendChild (element);
	}
	CategorySelect();
}

function ChangeUser(userSelect)
{
	select_user = userSelect.selectedIndex;
	
	widget.setPreferenceForKey(select_user, createkey("user"));

	iPalmMemoPlugin.setUser(select_user);

	CategorySelect();

	memo_count = iPalmMemoPlugin.getMemoCount();
	memoIdx = 0;
	
	refreshScreen();
}

function CategorySelect()
{
	var select = document.getElementById ('category-popup');
	var c = iPalmMemoPlugin.getCategoryCount();
	var len = select.length;
	
	for(idx=0;idx<len;idx++) {
		select.removeChild(select.lastChild);
	}

	for (var i = 0; i < c; ++i)
	{
		var element = document.createElement("option");
		element.innerText = iPalmMemoPlugin.getCategoryAtIndex(i);
		select.appendChild (element);
	}
}

function ChangeCategory(userSelect)
{
	iPalmMemoPlugin.setCategory(userSelect.selectedIndex);
	memoIdx = 0;
	memo_count = iPalmMemoPlugin.getMemoCount();
	if(memo_count > 0) {
		document.getElementById('memoContent').value = iPalmMemoPlugin.getMemoAtIndex(memoIdx);
	} else {
		document.getElementById('memoContent').value = "";
		memoIdx = -1;
	}
	refreshScreen();
}

function clickQueueSoft(event)
{
		widget.openURL (getLocalizedString("url"));
}

function showbackside(event)
{
	var front = document.getElementById("front");
	var back = document.getElementById("backpanel");
	
	if (window.widget)
		widget.prepareForTransition("ToBack");
	onhide();
	document.getElementById('version').innerHTML = version;
	document.getElementById('url-label').innerHTML = '<a href="' + getLocalizedString("url") + '">http://www.queuesoft.jp/</a>';
	front.style.display="none";
	back.style.display="block";
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);	


	document.getElementById('fliprollie').style.display = 'none';
}

function doneClicked() {
	var front = document.getElementById("front");
	var back = document.getElementById("backpanel");

	if (window.widget)
		widget.prepareForTransition("ToFront");


	front.style.display="block";
	back.style.display="none";

	setTimeout ('flipitback();', 0);
	onshow();

}


function flipitback()
{
//	updateTime(false);
	if (window.widget)
		setTimeout("widget.performTransition();", 0);
}

var flipShown = false;

var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, element:null, timer:null};


//  Returns val if min < val < max
//  Returns min if val <= min
//  Returns max if val >= max

function limit_3 (val, min, max)
{
    return val < min ? min : (val > max ? max : val);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

function animate()
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.element.style.opacity = animation.now;
}

function mousemove (event)
{
	if (!flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; // set it back one frame
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.element = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 1.0;
		animate();
		flipShown = true;
	}
}

function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the flip widget
		if (animation.timer != null)
		{
			clearInterval (animation.timer);
			animation.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; // set it back one frame
		
		animation.duration = 500;
		animation.starttime = starttime;
		animation.element = document.getElementById ('flip');
		animation.timer = setInterval ("animate();", 13);
		animation.from = animation.now;
		animation.to = 0.0;
		animate();
		flipShown = false;
	}
}

function onremove ()
{
	if (window.widget)
	{
		widget.setPreferenceForKey(null, createkey("user"));
	}
}

if (window.widget) {
	widget.onremove = onremove;
	widget.onhide = onhide;
	widget.onshow = onshow;
}

function enterflip(event)
{
	document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
	document.getElementById('fliprollie').style.display = 'none';
}

function createkey(key)
{
	return widget.identifier + "-" + key;
}

function debug(msg) {
	if (!debug.box) {
		debug.box = document.createElement("div");
		debug.box.setAttribute("style", "background-color: white; " +
										"font-family: monospace; " +
										"border: solid black 3px; " +
										"position: absolute;top:300px;" +
										"padding: 10px;");
		document.body.appendChild(debug.box);
		debug.box.innerHTML = "<h1 style='text-align:center'>Debug Output</h1>";
	}
	
	var p = document.createElement("p");
	p.appendChild(document.createTextNode(msg));
	debug.box.appendChild(p);
}
